package problem;

public class Node {

    protected Node parent;
    protected State state;
    protected int depth = 0;
    protected float g = 0;

    public Node(State state) {
        this.parent = null;
        this.state = state;
    }

//    public Node(State state, Node parent) {
//        this.parent = parent;
//        this.depth = parent.depth + 1;
//        this.state = state;
//        this.g = parent.g + 1;
//    }

    public Node(State state, Node parent, Action action) {
        this.parent = parent;
        this.depth = parent.depth + 1;
        this.state = state;
        this.g = parent.g + action.getCost();
    }

    public Node getParent() {
        return parent;
    }

    public State getState() {
        return state;
    }

    @Override
    public String toString() {
        return state.toString();
    }

    public int getDepth() {
        return depth;
    }

    public void setDepth(int depth) {
        this.depth = depth;
    }

    public boolean equals(Node n) {
        return state.equals(n.state);
    }

    public float getG() {
        return this.g;
    }
}
