package strategy;

import problem.Node;
import problem.Problem;

public abstract class Strategy {

    private int NumberOfProcessedNode = 0;//number og generated node
    private int MaximumNumberOfTreeNode = 0;//maximum tree node in memory
    private int numberOfNode = 0;

    public abstract Node Solve(Problem problem);

    protected void resetCalculatedComplexity(){
        this.numberOfNode=0;
        this.NumberOfProcessedNode=0;
        this.MaximumNumberOfTreeNode=0;
    }
    public int getNumberOfProcessedNode() {
        return this.NumberOfProcessedNode;
    }

    public int getMaximumNumberOfTreeNode() {
        return this.MaximumNumberOfTreeNode;
    }

    protected void incrementNumberOfNode() {
        this.NumberOfProcessedNode++;
        this.numberOfNode++;

        if (this.numberOfNode > this.MaximumNumberOfTreeNode) {
            this.MaximumNumberOfTreeNode = numberOfNode;
        }
    }

    protected void decrementNumberOfNode() {
        this.numberOfNode--;
    }
}
