package problem;

import strategy.Strategy;

public class Solver {

    private Problem problem;
    private Strategy strategy;
    public Problem setProblem(Problem problem) {
        this.problem = problem;
        return problem;
    }

    public Strategy setStrategy(Strategy strategy) {
        this.strategy = strategy;
        return strategy;
    }

 

    public void solve() {
        Node result = this.strategy.Solve(this.problem);
        this.problem.searchDone(result);
    }

    public Strategy getStrategy() {
        return strategy;
    }

    public Problem getProblem() {
        return problem;
    }
    
    
}
